set echo on
set serveroutput on

CREATE FUNCTION order_emps( p_column IN VARCHAR2 ) 
   RETURN SYS_REFCURSOR AS

   v_rc SYS_REFCURSOR;

BEGIN

   DBMS_OUTPUT.PUT_LINE('Ordering by ' || p_column || '...');

   OPEN v_rc FOR SELECT ename, job, hiredate, sal
                 FROM   emp
                 ORDER  BY
                        CASE UPPER(p_column)
                           WHEN 'ENAME'
                           THEN ename
                           WHEN 'SAL'
                           THEN TO_CHAR(sal,'fm0000')
                           WHEN 'JOB'
                           THEN job
                           WHEN 'HIREDATE'
                           THEN TO_CHAR(hiredate,'YYYYMMDD')
                        END;

   RETURN v_rc;

END order_emps;
/

var rc refcursor;
set autoprint on

exec :rc := order_emps('job');

exec :rc := order_emps('hiredate');

