
set echo on

EXPLAIN PLAN SET STATEMENT_ID = 'CASE'
FOR
SELECT e.ename
,      e.empno
,      e.job
,      e.sal
,      e.hiredate
,      d.deptno
FROM   dept d
,      emp  e
WHERE  d.deptno = e.deptno
AND    CASE
          WHEN e.deptno = 10
          AND  e.sal >= 1000
          THEN 0
          WHEN e.hiredate > DATE '1990-01-01'
          THEN 0
          WHEN d.loc = 'CHICAGO'
          THEN 0
          ELSE 1
       END = 1;

SELECT * FROM TABLE(DBMS_XPLAN.DISPLAY('PLAN_TABLE','CASE'));

EXPLAIN PLAN SET STATEMENT_ID = 'FILTERS'
FOR
SELECT e.ename
,      e.empno
,      e.job
,      e.sal
,      e.hiredate
,      d.deptno
FROM   dept d
,      emp  e
WHERE  d.deptno = e.deptno
AND    NOT (    e.deptno = 10
            AND e.sal >= 1000 )
AND    e.hiredate <= DATE '1990-01-01' 
AND    d.loc != 'CHICAGO';

SELECT * FROM TABLE(DBMS_XPLAN.DISPLAY('PLAN_TABLE','FILTERS'));

